
var start_date;
var end_date;
var period;
var div_width;
var counter_id;

var orig_color;


function load_report() {
  var date = new Date();
  var time_offset = date.getTimezoneOffset() * 60;
  $('#CounterReports').html("<div style='position: absolute; left: 40%; top: 50%;'><img src='"+ICON_PATH+"trash-loader.gif' alt='' /></div");
  $.ajax({
    url: NETCAT_PATH + '/modules/stats/openstat/ajax_reports.php?counter_id='+counter_id+
      "&from="+start_date+"&to="+end_date+"&period="+period+"&time_offset="+time_offset+
      "&width="+div_width,
    success: function (data) {
      $('#CounterReports').html(data);
    }
  });
}


function report_last_month() {
  $('#YesterdayLink').css("border-bottom", "2px dotted");
  $('#YesterdayLink').css("color", orig_color);
  $('#YesterdayLink').css("font-size", "1em");
  $('#LastWeekLink').css("border-bottom", "2px dotted");
  $('#LastWeekLink').css("color", orig_color);
  $('#LastWeekLink').css("font-size", "1em");
  $('#LastMonthLink').css("border", "0");
  $('#LastMonthLink').css("color", "black");
  $('#LastMonthLink').css("font-size", "1.4em");

  period = 'day';

  date = new Date(Date.now()-24*60*60*1000);
  end_date = Math.round(date.getTime()/1000);
  date.setMonth((date.getMonth() > 0 ? date.getMonth()-1 : 11), date.getDate());
  start_date = Math.round(date.getTime()/1000);

  load_report();
}

function report_last_week() {
  $('#YesterdayLink').css("border-bottom", "2px dotted");
  $('#YesterdayLink').css("color", orig_color);
  $('#YesterdayLink').css("font-size", "1em");
  $('#LastWeekLink').css("border", "0");
  $('#LastWeekLink').css("color", "black");
  $('#LastWeekLink').css("font-size", "1.4em");
  $('#LastMonthLink').css("border-bottom", "2px dotted");
  $('#LastMonthLink').css("color", orig_color);
  $('#LastMonthLink').css("font-size", "1em");

  period = 'day';

  end_date = Math.round(Date.now()/1000)-24*60*60;
  start_date = end_date - 7*24*60*60;

  load_report();
}


function report_yesterday() {
  $('#YesterdayLink').css("border", "0");
  $('#YesterdayLink').css("color", "black");
  $('#YesterdayLink').css("font-size", "1.4em");
  $('#LastWeekLink').css("border-bottom", "2px dotted");
  $('#LastWeekLink').css("color", orig_color);
  $('#LastWeekLink').css("font-size", "1em");
  $('#LastMonthLink').css("border-bottom", "2px dotted");
  $('#LastMonthLink').css("color", orig_color);
  $('#LastMonthLink').css("font-size", "1em");

  period = 'hour';

  date = new Date(Date.now()-24*60*60*1000);
  date.setHours(23);
  end_date = Math.round(date.getTime()/1000);
  date.setHours(0);
  start_date = Math.round(date.getTime()/1000);

  load_report();
}


// выкинуть!

function various_dates() {

  period = $('#StatsPeriodList').val();

  if (!(
        (parseInt($('#YearFrom').val(), 10) > 2000) &&
        (parseInt($('#YearFrom').val(), 10) < 2100) &&
        (parseInt($('#MonthFrom').val(), 10) > 0) &&
        (parseInt($('#MonthFrom').val(), 10) < 13) &&
        (parseInt($('#DayFrom').val(), 10) > 0) &&
        (parseInt($('#DayFrom').val(), 10) < 32) &&
        (parseInt($('#HourFrom').val(), 10) >= 0) &&
        (parseInt($('#HourFrom').val(), 10) < 24)
    )) {
    alert (INVALID_START_DATE);
    return;
  }

  if (! (
        (parseInt($('#YearTill').val(), 10) > 2000) &&
        (parseInt($('#YearTill').val(), 10) < 2100) &&
        (parseInt($('#MonthTill').val(), 10) > 0) &&
        (parseInt($('#MonthTill').val(), 10) < 13) &&
        (parseInt($('#DayTill').val(), 10) > 0) &&
        (parseInt($('#DayTill').val(), 10) < 32) &&
        (parseInt($('#HourTill').val(), 10) >= 0) &&
        (parseInt($('#HourTill').val(), 10) < 24)
    )) {
      alert (INVALID_END_DATE);
    return;
  }
  
  start_date = Date.UTC($('#YearFrom').val(), $('#MonthFrom').val()-1, $('#DayFrom').val());
  if (start_date == NaN) {
    alert (INVALID_START_DATE);
    return;
  }

  end_date = Date.UTC($('#YearTill').val(), $('#MonthTill').val()-1, $('#DayTill').val());
  if (start_date == NaN) {
    alert (INVALID_END_DATE);
    return;
  }

  start_date = Math.round(start_date / 1000);
  end_date = Math.round(end_date / 1000);

  if (end_date - start_date <= 0) {
    alert (START_DATE_TOO_BIG);
    return;
  }

  var divider;
  if (period == 'hour') divider = 60*60;
  else if (period == 'month') divider = 60*60*24*30;
  else if (period == 'week') divider = 60*60*24*7;
  else divider = 60*60*24;
  if ((end_date - start_date) / divider > 1000) {
    alert (INVALID_PERIOD);
    return;
  }
}
// выкинуть!
function cange_params() {
  period = $('#StatsPeriodList').val();
  switch (period) {
      case 'hour' :
        $('#TimeFrom').css('display', 'inline');
        $('#TimeTill').css('display', 'inline');
        $('#DayFrom').css('display', 'inline');
        $('#DayTill').css('display', 'inline');
        break;
      case 'day' :
      case 'week' :
        $('#TimeFrom').css('display', 'none');
        $('#TimeTill').css('display', 'none');
        $('#DayFrom').css('display', 'inline');
        $('#DayTill').css('display', 'inline');
        break;
      case 'month' :
        $('#TimeFrom').css('display', 'none');
        $('#TimeTill').css('display', 'none');
        $('#DayFrom').css('display', 'none');
        $('#DayTill').css('display', 'none');
        break;

  }
}



$('document').ready(function() {
  $('#CountersList').change(function () {
    document.location.href = '?phase=' + $('#CountersList').val();
  });
  
  counter_id = $('#CountersList').val();
  div_width = $('#CounterReports').width()-20;
  orig_color = $('#YesterdayLink').css("color");
  $('#YesterdayLink').click(report_yesterday);
  $('#LastWeekLink').click(report_last_week);
  $('#LastMonthLink').click(report_last_month);
  
  report_yesterday();


  $('#StatsPeriodList').change(cange_params);
  $('#ShowStat').click(various_dates);

});
