<?php
/* $Id: en.lang.php 5290 2011-09-05 09:50:45Z gaika $ */

define("NETCAT_MODULE_AUTH_DESCRIPTION", "The module \"User interface\" allows to realize such features as: Registration on the site; Change user profile; Change user password; Password recovery. You may integrate this module this other system components (modules, classes, etc.).");
define("NETCAT_MODULE_AUTH_REG_OK", "Registration was confirmed.");
define("NETCAT_MODULE_AUTH_REG_ERROR", "Error! Registration was NOT confirmed.");
define("NETCAT_MODULE_AUTH_REG_INVALIDLINK", "Invalid link.");
define("NETCAT_MODULE_AUTH_ERR_NEEDAUTH", "Need authorize.");
define("NETCAT_MODULE_AUTH_CHANGEPASS_NOTEQUAL", "Passwords are not equal. Try again.");
define("NETCAT_MODULE_AUTH_ERR_NOFIELDSET", "Field not set.");
define("NETCAT_MODULE_AUTH_ERR_NOUSERFOUND", "User not found");
define("NETCAT_MODULE_AUTH_MSG_FILLFIELD", "Fill one of these fields");
define("NETCAT_MODULE_AUTH_MSG_NEWPASSSENDED", "The confirmation letter has been sent to your e-mail. You should click on the link to confirm your request.");
define("NETCAT_MODULE_AUTH_MSG_INVALID_LOGIN_FORMAT","Invalid &laquo;Login&raquo; field format, you should use alphabet, numbers, underline, hyphen and space simbol.");
define("NETCAT_MODULE_AUTH_MSG_INVALID_EMAIL_FORMAT","Invalid &laquo;E-mail&raquo; field format, you should use alphabet, numbers, underline, hyphen and dot simbol.");
define("NETCAT_MODULE_AUTH_NEWPASS_SUCCESS", "The password is successfully changed.");
define("NETCAT_MODULE_AUTH_NEWPASS_ERROR", "Error while password change.");

define("NETCAT_MODULE_AUTH_FORM_AND_MAIL_TEMPLATES", "Mail templates");
define("NETCAT_MODULE_AUTH_EXTERNAL_AUTH", "Authorization through the external services");

define("NETCAT_MODULE_AUTH_LOGIN", "Login");
define("NETCAT_MODULE_AUTH_ENTER", "Enter");
define("NETCAT_MODULE_AUTH_REGISTER", "Register");
define("NETCAT_MODULE_AUTH_INCORRECT_LOGIN_OR_RASSWORD", "Username or password is incorrect");
define("NETCAT_MODULE_AUTH_AUTHORIZATION_UPPER", "AUTHORIZATION");
define("NETCAT_MODULE_AUTH_AUTHORIZATION", "Authorization");
define("NETCAT_MODULE_AUTH_FORGOT", "Forgot password");
define("NETCAT_MODULE_AUTH_PASSWORD", "Password");
define("NETCAT_MODULE_AUTH_FIRST_NAME", "Name");
define("NETCAT_MODULE_AUTH_LAST_NAME", "Surname");
define("NETCAT_MODULE_AUTH_NICKNAME", "Nickname");
define("NETCAT_MODULE_AUTH_PHOTO", "Photo");
define("NETCAT_MODULE_AUTH_SAVE", "Save login and password");
define("NETCAT_MODULE_AUTH_REMEMBER_ME", "Remember me");
define("NETCAT_MODULE_AUTH_NOT_NEW_MESSAGE", "Not new message");
define("NETCAT_MODULE_AUTH_NEW_MESSAGE", "New message");
define("NETCAT_MODULE_AUTH_HELLO", "Hello");
define("NETCAT_MODULE_AUTH_LOGOUT", "Logout");
define("NETCAT_MODULE_AUTH_BY_TOKEN", "Authorize by token");

define("NETCAT_MODULE_AUTH_LOGIN_WAIT","Please, wait");
define("NETCAT_MODULE_AUTH_LOGIN_FREE", "Login is free");
define("NETCAT_MODULE_AUTH_LOGIN_BUSY", "Login busy");
define("NETCAT_MODULE_AUTH_LOGIN_INCORRECT", "Login contains invalid characters");

define("NETCAT_MODULE_AUTH_PASS_LOW", "Low");
define("NETCAT_MODULE_AUTH_PASS_MIDDLE", "Average");
define("NETCAT_MODULE_AUTH_PASS_HIGH", "High");
define("NETCAT_MODULE_AUTH_PASS_VHIGH", "Very high");
define("NETCAT_MODULE_AUTH_PASS_EMPTY", "The password can't be empty");
define("NETCAT_MODULE_AUTH_PASS_SHORT", "The password too short");

define("NETCAT_MODULE_AUTH_PASS_COINCIDE", "Passwords coincide");
define("NETCAT_MODULE_AUTH_PASS_N_COINCIDE", "Passwords not coincide");

define("NETCAT_MODULE_AUTH_PASS_RELIABILITY", "Reliability:");

define("NETCAT_MODULE_AUTH_CP_NEWPASS", "New password");
define("NETCAT_MODULE_AUTH_CP_CONFIRM", "Confirm new password");
define("NETCAT_MODULE_AUTH_CP_DOBUTT", "Change password");

define("NETCAT_MODULE_AUTH_PRF_LOGIN", "Enter login");
define("NETCAT_MODULE_AUTH_PRF_EMAIL", "Or E-mail");
define("NETCAT_MODULE_AUTH_PRF_DOBUTT", "Generate new password");

define("NETCAT_MODULE_AUTH_BUT_AUTORIZE", "Auhtorize");
define("NETCAT_MODULE_AUTH_BUT_BACK", "Back");
define("NETCAT_MODULE_AUTH_MSG_AUTHISOK", "Authorization successful.");
define("NETCAT_MODULE_AUTH_MSG_AUTHUPISOK", "Session is closed."); 

define('NETCAT_MODULE_AUTH_MSG_SESSION_CLOSED', 'Session is closed. <a href=\'%s\'>Back</a>');
define('NETCAT_MODULE_AUTH_MSG_AUTH_SUCCESS', 'Authorization successful. <a href=\'%s\'>Back</a>');

define("NETCAT_MODULE_AUTH_ADMIN_SAVE_OK", "Settings updated successfully");

define("NETCAT_MODULE_AUTH_ADMIN_INFO", "You may edit HTML of user list and add, edit or delete \"Users\" in section \"<a href=/netcat/admin/field/system.php>System tables</a>\".<br><br>User control in section \"<a href=/netcat/admin/user/>Users and rights</a>\".");

// название вкладкок
define("NETCAT_MODULE_AUTH_ADMIN_TAB_INFO", "Information");
define("NETCAT_MODULE_AUTH_ADMIN_TAB_REGANDAUTH", "Registration and authorization");
define("NETCAT_MODULE_AUTH_ADMIN_TAB_TEMPLATES", "Templates");
define("NETCAT_MODULE_AUTH_ADMIN_TAB_MAIL", "Mail templates");
define("NETCAT_MODULE_AUTH_ADMIN_TAB_SETTINGS", "Settings");
define("NETCAT_MODULE_AUTH_ADMIN_TAB_CLASSIC", "Using login and password");
define("NETCAT_MODULE_AUTH_ADMIN_TAB_EXAUTH", "Through external services");
define("NETCAT_MODULE_AUTH_ADMIN_TAB_GENERAL", "General");
define("NETCAT_MODULE_AUTH_ADMIN_TAB_SYSTEM", "System");

// информация
define("NETCAT_MODULE_AUTH_ADMIN_INFO_USER_COUNT", "The total number of users");
define("NETCAT_MODULE_AUTH_ADMIN_INFO_USER_COUNT_UNCHECKED", "Users are unchecked");
define("NETCAT_MODULE_AUTH_ADMIN_INFO_USER_COUNT_UNCONFIRMED", "The number of users have not yet confirmed the registration");
define("NETCAT_MODULE_AUTH_ADMIN_INFO_NONE", "not");

// по логину и паролю
define("NETCAT_MODULE_AUTH_ADMIN_CLASSIC_DENY_REG", "Запретить самостоятельную регистрацию");
define("NETCAT_MODULE_AUTH_ADMIN_CLASSIC_DENY_RECOVERY", "Запретить самостоятельно восстанавливать пароли");
define("NETCAT_MODULE_AUTH_ADMIN_CLASSIC_ALLOW_CYRILLIC", "Разрешить кириллицу в логинах");
define("NETCAT_MODULE_AUTH_ADMIN_CLASSIC_ALLOW_SPECIALCHARS", "Разрешить спецсимволы в логинах");
define("NETCAT_MODULE_AUTH_ADMIN_CLASSIC_ALLOW_CHANGE_LOGIN", "Разрешить менять логин после регистрации");
define("NETCAT_MODULE_AUTH_ADMIN_CLASSIC_BING_TO_CATALOGUE", "Привязывать пользователя к сайту");
define("NETCAT_MODULE_AUTH_ADMIN_CLASSIC_WITH_SUBDOMAIN", "Авторизировать на поддоменах");
define("NETCAT_MODULE_AUTH_ADMIN_CLASSIC_AUTH_CAPTCHA_NUM", "Показывать CAPTCHA после %input попыток авторизации ( 0 - не показывать)");
define("NETCAT_MODULE_AUTH_ADMIN_CLASSIC_PASS_MIN", "Минимальная длина пароля %input символов");
define("NETCAT_MODULE_AUTH_ADMIN_CLASSIC_REGISTRATION_FORM", "Форма регистрации");
define("NETCAT_MODULE_AUTH_ADMIN_CLASSIC_CHECK_LOGIN", "Автоматически проверять доступность логина");
define("NETCAT_MODULE_AUTH_ADMIN_CLASSIC_CHECK_PASS", "Автоматически проверять уровень безопасности пароля");
define("NETCAT_MODULE_AUTH_ADMIN_CLASSIC_CHECK_PASS2", "Автоматически проверять совпадение паролей");
define("NETCAT_MODULE_AUTH_ADMIN_CLASSIC_CHECK_AGREED", "Требовать соглашения с пользовательским соглашением");
define("NETCAT_MODULE_AUTH_ADMIN_CLASSIC_FIELDS_IN_REG_FORM", "Поля в форме регистрации");
define("NETCAT_MODULE_AUTH_ADMIN_CLASSIC_FIELDS_IN_REG_FORM_ALL", "все");
define("NETCAT_MODULE_AUTH_ADMIN_CLASSIC_FIELDS_IN_REG_FORM_CUSTOM", "выборочно");
define("NETCAT_MODULE_AUTH_ADMIN_CLASSIC_ACTIVATION", "Активация");
define("NETCAT_MODULE_AUTH_ADMIN_CLASSIC_CONFIRM", "Требовать подтверждение через почту");
define("NETCAT_MODULE_AUTH_ADMIN_CLASSIC_PREMODARATION", "Премодерация администратором");
define("NETCAT_MODULE_AUTH_ADMIN_CLASSIC_NOTIFY_ADMIN", "Отправлять письмо администратору при регистрации пользователя");
define("NETCAT_MODULE_AUTH_ADMIN_CLASSIC_AUTHAUTORIZE", "Авторизация пользователя сразу после подтверждения");
define("NETCAT_MODULE_AUTH_ADMIN_CLASSIC_CONFIRM_TIME", "Удалять пользователя, если он подтвердил регистрацию в течение %input часов");

// через внешние сервисы
define("NETCAT_MODULE_AUTH_ADMIN_EX_CURL_REQUIRED", "Для авторизации через внешние сервисы необходима библиотека <a href='http://www.php.net/manual/ru/book.curl.php'>cURL</a>");
define("NETCAT_MODULE_AUTH_ADMIN_EX_JSON_REQUIRED", "Для авторизации через внешние сервисы необходима библиотека <a href='http://ru2.php.net/manual/en/book.json.php'>JSON</a>");
define("NETCAT_MODULE_AUTH_ADMIN_EX_VK", "ВКонтакте");
define("NETCAT_MODULE_AUTH_ADMIN_EX_FB", "Facebook");
define("NETCAT_MODULE_AUTH_ADMIN_EX_TWITTER", "Twitter");
define("NETCAT_MODULE_AUTH_ADMIN_EX_OPENID", "OpenID");
define("NETCAT_MODULE_AUTH_ADMIN_EX_VK_ENABLED", "Включить авторизацию через vkontakte.ru");
define("NETCAT_MODULE_AUTH_ADMIN_EX_FB_ENABLED", "Включить авторизацию через facebook.com");
define("NETCAT_MODULE_AUTH_ADMIN_EX_OPENID_ENABLED", "Включить авторизацию через OpenID");
define("NETCAT_MODULE_AUTH_ADMIN_EX_TWITTER_ENABLED", "Включить авторизацию через twitter.com");
define("NETCAT_MODULE_AUTH_ADMIN_EX_DATA_VK", "Данные из ВКонтакте");
define("NETCAT_MODULE_AUTH_ADMIN_EX_DATA_FB", "Данные из Facebook");
define("NETCAT_MODULE_AUTH_ADMIN_EX_DATA_TWITTER", "Данные из Twitter");
define("NETCAT_MODULE_AUTH_ADMIN_EX_DATA_OPENID", "Данные из OpenID");

// общие настройки
define("NETCAT_MODULE_AUTH_ADMIN_GENERAL_AUTH_SITE", "Способы авторизации на сайте");
define("NETCAT_MODULE_AUTH_ADMIN_GENERAL_AUTH_ADMIN", "Способы авторизации в систему администрирования");
define("NETCAT_MODULE_AUTH_ADMIN_GENERAL_METHOD_LOGIN", "По логину и паролю");
define("NETCAT_MODULE_AUTH_ADMIN_GENERAL_METHOD_TOKEN", "По usb-токену");
define("NETCAT_MODULE_AUTH_ADMIN_GENERAL_METHOD_HASH", "По хэшу");
define("NETCAT_MODULE_AUTH_ADMIN_GENERAL_METHOD_EX", "Через внешние сервисы");
define("NETCAT_MODULE_AUTH_ADMIN_GENERAL_PM", "Личные сообщения");
define("NETCAT_MODULE_AUTH_ADMIN_GENERAL_PM_ALLOW", "Разрешить отправлять личные сообщения");
define("NETCAT_MODULE_AUTH_ADMIN_GENERAL_PM_NOTIFY", "Оповещать пользователя по e-mail о новом сообщение");
define("NETCAT_MODULE_AUTH_ADMIN_GENERAL_FRIEND_BANNED", "Друзья и враги");
define("NETCAT_MODULE_AUTH_ADMIN_GENERAL_FRIEND_ALLOW", "Разрешить добавлять пользователей в друзья");
define("NETCAT_MODULE_AUTH_ADMIN_GENERAL_BANNED_ALLOW", "Разрешить добавлять пользователей во враги");
define("NETCAT_MODULE_AUTH_ADMIN_GENERAL_PA", "Личный счет");
define("NETCAT_MODULE_AUTH_ADMIN_GENERAL_PA_ALLOW", "Ввести личный счет");
define("NETCAT_MODULE_AUTH_ADMIN_GENERAL_PA_CURRENCY", "Единица измерения %input");
define("NETCAT_MODULE_AUTH_ADMIN_GENERAL_PA_START", "Начислять вновь зарегистрированным %input единиц");

// письма
define("NETCAT_MODULE_AUTH_ADMIN_MAIL_SUBJECT", "Заголовок письма");
define("NETCAT_MODULE_AUTH_ADMIN_MAIL_BODY", "Тело письма");
define("NETCAT_MODULE_AUTH_ADMIN_MAIL_HTML", "HTML-письмо");

// системные настройки
define("NETCAT_MODULE_AUTH_ADMIN_SYSTEM_COMPONENTS_SUBS", "Компоненты, разделы и поля");
define("NETCAT_MODULE_AUTH_ADMIN_SYSTEM_COMPONENT_FRIENDS", "Компонент \"Список друзей\"");
define("NETCAT_MODULE_AUTH_ADMIN_SYSTEM_COMPONENT_PM", "Компонент для личных сообщениях");
define("NETCAT_MODULE_AUTH_ADMIN_SYSTEM_COMPONENT_PA", "Компонент для личного счета");
define("NETCAT_MODULE_AUTH_ADMIN_SYSTEM_FIELD_PA", "Поле c балансом для личного счета");
define("NETCAT_MODULE_AUTH_ADMIN_SYSTEM_SUB_MATERIALS", "Раздел с материалами пользователя");
define("NETCAT_MODULE_AUTH_ADMIN_SYSTEM_SUB_MODIFY", "User modify subdivisions");
define("NETCAT_MODULE_AUTH_ADMIN_SYSTEM_CC_USER_LIST", "Subdivision with users");
define("NETCAT_MODULE_AUTH_ADMIN_SYSTEM_PSEUDO", "Псевдопользователи");
define("NETCAT_MODULE_AUTH_ADMIN_SYSTEM_PSEUDO_ALLOW", "Доступны псевдопользователи");
define("NETCAT_MODULE_AUTH_ADMIN_SYSTEM_PSEUDO_CHECK_IP", "Проверять IP");
define("NETCAT_MODULE_AUTH_ADMIN_SYSTEM_PSEUDO_GROUP", "Группа псевдопользователей");
define("NETCAT_MODULE_AUTH_ADMIN_SYSTEM_PSEUDO_FIELD", "Поле, по которому идет индетификация");
define("NETCAT_MODULE_AUTH_ADMIN_SYSTEM_HASH", "Хэш-авторизация");
define("NETCAT_MODULE_AUTH_ADMIN_SYSTEM_HASH_DELETE", "Удалять хэш после авторизации");
define("NETCAT_MODULE_AUTH_ADMIN_SYSTEM_HASH_EXPIRE", "Время жизни хэша в часах %input");
define("NETCAT_MODULE_AUTH_ADMIN_SYSTEM_HASH_DISABLED_SUBS", "Номера разделов, где запрещена хэш-авторизация, через запятую %input");
define("NETCAT_MODULE_AUTH_ADMIN_SYSTEM_OTHER", "Прочее");
define("NETCAT_MODULE_AUTH_ADMIN_SYSTEM_OTHER_ONLINE", "Время, в течение которого пользователь считается online в секундах %input");
define("NETCAT_MODULE_AUTH_ADMIN_SYSTEM_OTHER_IP", "Уровень проверки IP-адреса (0-4) %input");

define("NETCAT_MODULE_AUTH_SELFREG_DISABLED", "Самостоятельная регистрация запрещена");



define("NETCAT_MODULE_AUTH_FORM_TEMPLATES", "Шаблоны форм");
define("NETCAT_MODULE_AUTH_FORM_AUTH", "Форма авторизации");
define("NETCAT_MODULE_AUTH_RESTORE_DEF", "Восстановить значения по умолчанию");
define("NETCAT_MODULE_AUTH_FORM_DISABLED", "Не показывать форму при неудачной попытке авторизации");
define("NETCAT_MODULE_AUTH_FORM_CHG_PASS", "Форма изменения пароля");
define("NETCAT_MODULE_AUTH_FORM_CHG_PASS_AFTER", "Текст, выводимый после смены пароля");
define("NETCAT_MODULE_AUTH_FORM_REC_PASS_AFTER", "Текст, выводимый после отправки письма");
define("NETCAT_MODULE_AUTH_FORM_CHG_PASS_WARNBLOCK", "Блок вывода ошибки");
define("NETCAT_MODULE_AUTH_FORM_CHG_PASS_DENY", "Текст, выводимый при запрете восстановления пароля");
define("NETCAT_MODULE_AUTH_FORM_REC_PASS", "Форма восстановления пароля");
define("NETCAT_MODULE_AUTH_MAIL_TEMPLATES", "Шаблоны писем");
define("NETCAT_MODULE_AUTH_REG_CONFIRM", "Подтверждение регистрации");
define("NETCAT_MODULE_AUTH_AS_HTML", "HTML текст");
define("NETCAT_MODULE_AUTH_RECOVERY", "Восстановление пароля");
define("NETCAT_MODULE_AUTH_ADMIN_MAIL_NOTIFY", "Оповещение администратора о регистрации пользователя");

define("NETCAT_MODULE_AUTH_ADD_FRIEND", "Add to friends");
define("NETCAT_MODULE_AUTH_REMOVE_FRIEND", "Remove from friends");

// OpenID
define("NETCAT_MODULE_AUTH_OPEN_ID_ERROR", "Undefined OpenID");
define("NETCAT_MODULE_AUTH_OPEN_ID_INVALID", "Invalid OpenID");
define("NETCAT_MODULE_AUTH_OPEN_ID_ALREADY_EXIST_IN_BASE", "This OpenID already exist into the base");
define("NETCAT_MODULE_AUTH_OPEN_ID_COULD_NOT_REDIRECT_TO_SERVER", "Could not redirect to server: %s");
define("NETCAT_MODULE_AUTH_OPEN_ID_CHECK_CANCELED", "Auth breaking");
define("NETCAT_MODULE_AUTH_OPEN_ID_AUTH_FAILED", "OpenID auth failed: %s");
define("NETCAT_MODULE_AUTH_OPEN_ID_AUTH_COMPLETE_NAME", "Auth succesfull as <a href='%s'>%s</a> ");
define("NETCAT_MODULE_AUTH_OPEN_ID_AUTH_COMPLETE_LOGIN", "Your login: %s");


define("NETCAT_MODULE_AUTH_SETUP_REGISTRATION", "Регистрация");
define("NETCAT_MODULE_AUTH_SETUP_PASSWORD_RECOVERY", "Восстановление пароля");
define("NETCAT_MODULE_AUTH_SETUP_MODIFY", "Изменение анкеты");
define("NETCAT_MODULE_AUTH_SETUP_PASSWORD", "Изменение пароля");


define("NETCAT_MODULE_AUTH_APPLICATION_ID_VK", "ID приложения");
define("NETCAT_MODULE_AUTH_APPLICATION_ID_FB", "ID приложения (Application ID)");
define("NETCAT_MODULE_AUTH_APPLICATION_ID_TWITTER", "ID приложения (Consumer key)");
define("NETCAT_MODULE_AUTH_SECRET_KEY_VK", "Защищенный ключ");
define("NETCAT_MODULE_AUTH_SECRET_KEY_FB", "Защищенный ключ (Application Secret)");
define("NETCAT_MODULE_AUTH_SECRET_KEY_TWITTER", "Защищенный ключ (Consumer secret)");

define("NETCAT_MODULE_AUTH_GROUPS_WHERE_USER_WILL_BE", "Группы, куда попадёт пользователь");
define("NETCAT_MODULE_AUTH_ACTION_AFTER_FIRST_AUTHORIZATION", "Действие после первой авторизации пользоваетля");
define("NETCAT_MODULE_AUTH_ACTION_FIELDS_MAPPING", "Соответсвие полей");
define("NETCAT_MODULE_AUTH_ACTION_FIELDS_MAPPING_ADD", "Добавить соответствие");
define("NETCAT_MODULE_AUTH_PROVIDER_ADD", "Добавить провайдера");


define("NETCAT_MODULE_AUTH_ADMIN_DEF_MAIL_CONFIRM_SUBJECT", "Подтверждение регистрации на сайте %SITE_NAME");
define("NETCAT_MODULE_AUTH_ADMIN_DEF_MAIL_CONFIRM_BODY",
"Здравствуйте, %USER_LOGIN

Вы успешно зарегистрировались на сайте <a href='%SITE_URL'>%SITE_NAME</a>
Ваш логин: 	%USER_LOGIN
Ваш пароль: 	%PASSWORD

Чтобы активировать Ваш аккаунт откройте, пожалуйста, данную ссылку:

<a href='%CONFIRM_LINK'>%CONFIRM_LINK</a>

Вы получили это сообщение, потому что Ваш e-mail адрес был зарегистрирован на сайте %SITE_URL
Если Вы не регистрировались на этом сайте, пожалуйста, проигнорируйте это письмо.

С наилучшими пожеланиями, администрация сайта <a href='%SITE_URL'>%SITE_NAME</a>.
");
define("NETCAT_MODULE_AUTH_ADMIN_DEF_MAIL_PASSWORDRECOVERY_SUBJECT", "Восстановление пароля на сайте %SITE_NAME");
define("NETCAT_MODULE_AUTH_ADMIN_DEF_MAIL_PASSWORDRECOVERY_BODY",
"Здравствуйте, %USER_LOGIN

Для восстановления пароля для пользователя %USER_LOGIN на сайте <a href='%SITE_URL'>%SITE_NAME</a> откройте, пожалуйста, данную ссылку:

<a href='%CONFIRM_LINK'>%CONFIRM_LINK</a>

Если Вы не запрашивали восстановление пароля, пожалуйста, проигнорируйте это письмо.

С наилучшими пожеланиями, администрация сайта <a href='%SITE_URL'>%SITE_NAME</a>.
");
define("NETCAT_MODULE_AUTH_ADMIN_DEF_MAIL_ADMIN_NOTIFY_SUBJECT", "Новый пользователь на сайте %SITE_NAME");
define("NETCAT_MODULE_AUTH_ADMIN_DEF_MAIL_ADMIN_NOTIFY_BODY",
"Здравствуйте, администратор.

На сайте <a href='%SITE_URL'>%SITE_NAME</a> зарегистрирован новый пользователь с логином %USER_LOGIN

С наилучшими пожеланиями, сайт <a href='%SITE_URL'>%SITE_NAME</a>.
");

?>