/* $Id: url_routes.js 5445 2011-10-11 15:54:53Z gaika $ */

urlDispatcher.route = {

  'index': ADMIN_PATH+'index_page.php',

  // создание раздела (parent_sub_id, catalogue_id)
  'subdivision.add': ADMIN_PATH+'subdivision/index.php?phase=2&ParentSubID=%1&CatalogueID=%2',
  // редактирование раздела
  'subdivision.edit': ADMIN_PATH+'subdivision/index.php?phase=5&SubdivisionID=%1&view=edit',
  'subdivision.design': ADMIN_PATH+'subdivision/index.php?phase=5&SubdivisionID=%1&view=design',
  'subdivision.seo': ADMIN_PATH+'subdivision/index.php?phase=5&SubdivisionID=%1&view=seo',
  'subdivision.system': ADMIN_PATH+'subdivision/index.php?phase=5&SubdivisionID=%1&view=system',
  'subdivision.fields': ADMIN_PATH+'subdivision/index.php?phase=5&SubdivisionID=%1&view=fields',
  // удаление раздела
  'subdivision.delete': ADMIN_PATH+'subdivision/index.php?phase=7&Delete%1=%1',
  // информация о разделе
  'subdivision.info': ADMIN_PATH+'subdivision/index.php?phase=4&SubdivisionID=%1',
  // список подразделов
  'subdivision.sublist': ADMIN_PATH+'subdivision/index.php?phase=1&ParentSubID=%1',
  // список шаблонов в разделе
//  'subdivision.cclist': ADMIN_PATH+'subdivision/SubClass.php?SubdivisionID=%1',
  // Права пользователей на действия в разделе
  'subdivision.userlist': ADMIN_PATH+'subdivision/index.php?phase=15&SubdivisionID=%1',
  // просмотр раздела
  'subdivision.view': ADMIN_PATH+'subdivision/index.php?phase=14&SubdivisionID=%1',
  // используемые шаблоны
  'subdivision.subclass': ADMIN_PATH+'subdivision/SubClass.php?SubdivisionID=%1',
  
  // список шаблонов в разделе
  'subclass.list': ADMIN_PATH+'subdivision/SubClass.php?SubdivisionID=%1',
  // создание шаблона в разделе
  'subclass.add': ADMIN_PATH+'subdivision/SubClass.php?phase=1&SubdivisionID=%1',

  // редактирование шаблона в разделе
  'subclass.edit': ADMIN_PATH+'subdivision/SubClass.php?phase=3&SubClassID=%1&SubdivisionID=%2',

  // удаление всех объектов в шаблоне-в-разделе
  'subclass.purge': NETCAT_PATH+'message.php?cc=%1&delete=1&inside_admin=1',

  // просмотр шаблона раздела
  'subclass.view': ADMIN_PATH+'subdivision/index.php?phase=14&SubClassID=%2',
  
  // удаление шаблона в разделе
  //'subclass.delete': ADMIN_PATH+''+subclassId,

  // список объектов
  'object.list': NETCAT_PATH+'?inside_admin=1&cc=%1',

  // редактирование объекта
  'object.edit': NETCAT_PATH+'message.php?inside_admin=1&classID=%1&message=%2',

  // создание объекта
  'object.add': NETCAT_PATH+'add.php?inside_admin=1&cc=%1',

  // список всех сайтов
  'site.list': ADMIN_PATH+'catalogue/index.php',
  // создание сайта
  'site.add': ADMIN_PATH+'catalogue/index.php?phase=2&type=1',
  // настройки сайта
  'site.edit': ADMIN_PATH+'catalogue/index.php?phase=2&type=2&CatalogueID=%1',
  // удаление сайта
  'site.delete': ADMIN_PATH+'catalogue/index.php?phase=4&Delete%1=%1',
  // карта сайта
  'site.map': ADMIN_PATH+'subdivision/full.php?CatalogueID=%1',
  // SEO
  'site.seo': ADMIN_PATH+'siteinfo/?url=%1&CatalogueID=%2',
  // статистика
  'site.stat.nc_stat': NETCAT_PATH+'modules/stats/admin.php?phase=9&cat_id=%1',
  'site.stat.openstat': NETCAT_PATH+'modules/stats/openstat/admin.php?catalog_page=%1',
  // информация
  'site.info': ADMIN_PATH+'catalogue/index.php?phase=6&CatalogueID=%1',
  // список разделов
  'site.sublist': ADMIN_PATH+'subdivision/index.php?phase=1&CatalogueID=%1&ParentSubID=%2',
  // Мастер создания сайта
  'site.wizard': ADMIN_PATH + 'wizard/wizard_site.php?phase=%1&CatalogueID=%2',

  /*
   * Работа с группами шаблонов
   */
  // Добавление группы шаблонов
  /*
  'classgroup.add':
   ADMIN_PATH+'class/index.php?phase=10'
  */
  // Редактирование группы шаблонов
  'classgroup.edit': ADMIN_PATH+'class/index.php?phase=1&ClassGroup=%1',

  /*
   * Работа с шаблонами
   */
  // Вывод списка шаблонов
  'dataclass.list': ADMIN_PATH+'class/',
  // Информация о шаблоне
  'dataclass.info': ADMIN_PATH+'class/index.php?phase=13&ClassID=%1',
  // Добавление шаблона
  'dataclass.add': ADMIN_PATH+'class/index.php?phase=10&ClassGroup=%1',
  // Редактирование шаблона
  'dataclass.edit': ADMIN_PATH+'class/index.php?phase=4&ClassID=%1',
  // Удаление шаблона
  'dataclass.delete': ADMIN_PATH+'class/index.php?phase=6&Delete%1=%1',
  // Шаблоны действий
  'dataclass.classaction': ADMIN_PATH+'class/index.php?phase=8&myaction=1&ClassID=%1',
  // Редактирование альтернативного шаблона добавления
  'dataclass.customadd': ADMIN_PATH+'class/index.php?phase=8&myaction=1&ClassID=%1',
  // Редактирование альтернативного шаблона измениения
  'dataclass.customedit': ADMIN_PATH+'class/index.php?phase=8&myaction=2&ClassID=%1',
  // Редактирование альтернативного шаблона поиска
  'dataclass.customsearch': ADMIN_PATH+'class/index.php?phase=8&myaction=3&ClassID=%1',
  // Редактирование альтернативного шаблона подписки
  //'dataclass.customsubscribe': ADMIN_PATH+'class/index.php?phase=8&myaction=4&ClassID=%1',
  // Редактирование альтернативного шаблона удаления
  'dataclass.customdelete': ADMIN_PATH+'class/index.php?phase=8&myaction=5&ClassID=%1',
  // Список полей шаблона
  'dataclass.fields': ADMIN_PATH+'field/index.php?ClassID=%1',
  // Пользовательские настройки
  'dataclass.custom': ADMIN_PATH+'class/index.php?phase=24&ClassID=%1',
  // Редактирование одной настройки
  'dataclass.custom.edit': ADMIN_PATH+'class/index.php?phase=25&ClassID=%1&param=%2',
  // создание новой настройки
  'dataclass.custom.new': ADMIN_PATH+'class/index.php?phase=25&ClassID=%1',
   // ручное редактирование
  'dataclass.custom.manual': ADMIN_PATH+'class/index.php?phase=26&ClassID=%1',
  // Импорт шаблона
  'dataclass.import': ADMIN_PATH+'class/import.php',
  // Мастер создания шаблона
  'dataclass.wizard': ADMIN_PATH + 'wizard/wizard_class.php?phase=%1&Class_Type=%2&ClassID=%3',

  /*
   * Работа с шаблонами компонентов
   */
  // Редактирование группы шаблонов компонента
  'classtemplates.edit': ADMIN_PATH + 'class/index.php?phase=20&ClassID=%1',
  // Добавление шаблона компонента
  'classtemplate.add': ADMIN_PATH + 'class/index.php?phase=14&ClassID=%1',
  // Редактирование шаблона компонента
  'classtemplate.edit': ADMIN_PATH + 'class/index.php?phase=16&ClassID=%1',
  // Удаление шаблона компонента
  'classtemplate.delete': ADMIN_PATH + 'class/index.php?phase=18&Delete%1=%1&ClassTemplate=%2',
  // Шаблоны действий
  'classtemplate.classaction': ADMIN_PATH + 'class/index.php?phase=22&myaction=1&ClassID=%1',
  // Редактирование альтернативного блока добавления
  'classtemplate.customadd': ADMIN_PATH + 'class/index.php?phase=22&myaction=1&ClassID=%1',
  // Редактирование альтернативного блока измениения
  'classtemplate.customedit': ADMIN_PATH + 'class/index.php?phase=22&myaction=2&ClassID=%1',
  // Редактирование альтернативного блока поиска
  'classtemplate.customsearch': ADMIN_PATH + 'class/index.php?phase=22&myaction=3&ClassID=%1',
  // Редактирование альтернативного блока подписки
  //'classtemplate.customsubscribe': ADMIN_PATH + 'class/index.php?phase=22&myaction=4&ClassID=%1',
  // Редактирование альтернативного блока удаления
  'classtemplate.customdelete': ADMIN_PATH + 'class/index.php?phase=22&myaction=5&ClassID=%1',
// Пользовательские настройки
  'classtemplate.custom': ADMIN_PATH+'class/index.php?phase=240&ClassID=%1',
  // Редактирование одной настройки
  'classtemplate.custom.edit': ADMIN_PATH+'class/index.php?phase=250&ClassID=%1&param=%2',
  // создание новой настройки
  'classtemplate.custom.new': ADMIN_PATH+'class/index.php?phase=250&ClassID=%1',
   // ручное редактирование
  'classtemplate.custom.manual': ADMIN_PATH+'class/index.php?phase=260&ClassID=%1',

  /*
   * Работа с виджетами
   */
  'widgetclass.list' : ADMIN_PATH + 'widget/',
  'widgetclass.add': ADMIN_PATH + 'widget/index.php?phase=20&widget_group=%1',
  'widgetclass.edit' : ADMIN_PATH + 'widget/index.php?phase=30&widgetclass_id=%1',
  'widgetclass.info' : ADMIN_PATH + 'widget/index.php?phase=40&widgetclass_id=%1',
  'widgetclass.action' : ADMIN_PATH + 'widget/index.php?phase=50&widgetclass_id=%1',
  'widgetclass.drop' : ADMIN_PATH + 'widget/index.php?phase=60&widgetclass_id=%1&from_tree=%2',
  'widgetclass.fields': ADMIN_PATH + 'field/index.php?widgetclass_id=%1',
  'widgetclass.import': ADMIN_PATH + 'widget/index.php?phase=80',
  'widgetgroup.edit': ADMIN_PATH+'widget/index.php?phase=10&category=%1',
  'widgetfield.add': ADMIN_PATH+'field/index.php?phase=2&widgetclass_id=%1',
  'widgetfield.edit': ADMIN_PATH+'field/index.php?phase=4&FieldID=%1&widgetclass_id=%2',
  'widgetfield.delete': ADMIN_PATH+'field/index.php?phase=6&widgetclass_id=%1&Delete[]=%2',
  'widgets': ADMIN_PATH+'widget/admin.php',
  'widgets.add': ADMIN_PATH+'widget/admin.php?phase=20&widget_id=%1',
  'widgets.edit': ADMIN_PATH+'widget/admin.php?phase=30&widget_id=%1',
  'widgets.delete': ADMIN_PATH+'widget/admin.php?phase=60&widget_id=%1',

  /*
   * Работа с системными таблицами
   */
  // Список системных таблиц
  'systemclass.list': ADMIN_PATH+'field/system.php',
  // Редактирование системной таблицы
  'systemclass.edit': ADMIN_PATH+'field/system.php?phase=2&SystemTableID=%1',
  // Редактирование альтернативного шаблона добавления
  'systemclass.customadd': ADMIN_PATH+'field/system.php?phase=4&myaction=1&SystemTableID=%1',
  // Редактирование альтернативного шаблона измениения
  'systemclass.customedit': ADMIN_PATH+'field/system.php?phase=4&myaction=2&SystemTableID=%1',
  // Редактирование альтернативного шаблона поиска
  'systemclass.customsearch': ADMIN_PATH+'field/system.php?phase=4&myaction=3&SystemTableID=%1',
  // Список полей шаблона
 // 'systemclass.fields': ADMIN_PATH+'field/systemField.php?SystemTableID=%1',
 'systemclass.fields': ADMIN_PATH+'field/index.php?isSys=1&SystemTableID=%1',

  /*
   * Работа с полями шаблона
   */
  // Добавление поля шаблона
  'field.add': ADMIN_PATH+'field/index.php?phase=2&ClassID=%1',
  // Редактирование поля шаблона
  'field.edit': ADMIN_PATH+'field/index.php?phase=4&FieldID=%1',
  // Удаление поля шаблона
  'field.delete': ADMIN_PATH+'field/index.php?phase=6&ClassID=%1&Delete[]=%2',


  /*
   * Работа с системными полями
   */
  // Добавление поля шаблона
 // 'systemfield.add': ADMIN_PATH+'field/systemField.php?phase=2&SystemTableID=%1',
  // Редактирование поля шаблона
  //'systemfield.edit': ADMIN_PATH+'field/systemField.php?phase=4&FieldID=%1',
  // Удаление поля шаблона
  //'systemfield.delete': ADMIN_PATH+'field/systemField.php?phase=6&SystemTableID=%1&Delete[]=%2',
   // Добавление поля шаблона
  'systemfield.add': ADMIN_PATH+'field/index.php?phase=2&isSys=1&SystemTableID=%1',
  // Редактирование поля шаблона
  'systemfield.edit': ADMIN_PATH+'field/index.php?phase=4&isSys=1&FieldID=%1',
  // Удаление поля шаблона
  'systemfield.delete': ADMIN_PATH+'field/index.php?phase=6&isSys=1&SystemTableID=%1&Delete[]=%2',


  /*
   * Работа со списками
   */
  // Вывод списка
  'classificator.list': ADMIN_PATH+'classificator.php',
  // Добавление списка
  'classificator.add': ADMIN_PATH+'classificator.php?phase=1',
  // Редактирование списка
  'classificator.edit': ADMIN_PATH+'classificator.php?phase=4&ClassificatorID=%1',
  // Удаление списка
  'classificator.delete': ADMIN_PATH+'classificator.php?phase=3&Delete%1=%1',
  // Импорт списка
  'classificator.import': ADMIN_PATH+'classificator.php?phase=12',
  // Редактирование элемента списка
  'classificator.item.edit': ADMIN_PATH+'classificator.php?phase=10&ClassificatorID=%1&IdInClassificator=%2',
  // Добавление элемента списка
  'classificator.item.add': ADMIN_PATH+'classificator.php?phase=8&ClassificatorID=%1',


  /*
   * Работа с макетами
   */
  'template.list': ADMIN_PATH+'template/index.php',
  // Добавление макета
  'template.add': ADMIN_PATH+'template/index.php?phase=2&ParentTemplateID=%1',
  // Редактирование макета
  'template.edit': ADMIN_PATH+'template/index.php?phase=4&TemplateID=%1',
  // Удаление макета
  'template.delete': ADMIN_PATH+'template/index.php?phase=6&Delete%1=%1',
  // Пользовательские настройки
  'template.custom': ADMIN_PATH+'template/index.php?phase=8&TemplateID=%1',
  // Редактирование одной настройки
  'template.custom.edit': ADMIN_PATH+'template/index.php?phase=9&TemplateID=%1&param=%2',
  // создание новой настройки
  'template.custom.new': ADMIN_PATH+'template/index.php?phase=9&TemplateID=%1',
  // ручное редактирование
  'template.custom.manual': ADMIN_PATH+'template/index.php?phase=10&TemplateID=%1',


  /*
   * Стандартные модули
   *  адреса для пользовательских модулей могут быть заданы в
   *  файле modules/имяМодуля/url_routes.js:
   *   urlDispatcher.route['url'] = 'path';
   */
  'module.auth': NETCAT_PATH+'modules/auth/admin.php',
  'module.banner': NETCAT_PATH+'modules/banner/admin.php',
  'module.forum': NETCAT_PATH+'modules/forum/admin.php',
  'module.linkmanager': NETCAT_PATH+'modules/linkmanager/admin.php?page=%1',
  'module.netshop': NETCAT_PATH+'modules/netshop/admin.php',
  'module.search': NETCAT_PATH+'modules/search/admin.php?page=%1',
  'module.searchold': NETCAT_PATH+'modules/searchold/admin.php?page=%1',
  'module.stats': NETCAT_PATH+'modules/stats/admin.php?phase=9&cat_id=%1',
  'module.openstat': NETCAT_PATH+'modules/stats/admin.php?phase=11',
  'module.subscriber': NETCAT_PATH+'modules/subscriber/admin.php',
  'module.tagscloud': NETCAT_PATH+'modules/tagscloud/admin.php',
  'module.blog': NETCAT_PATH+'modules/blog/admin.php',
  'module.calendar': NETCAT_PATH+'modules/calendar/admin.php',


  // действия с пользователями
  'user.list': ADMIN_PATH + 'user/',
  'user.add': ADMIN_PATH + 'user/register.php',
  'user.edit': ADMIN_PATH + 'user/index.php?phase=4&UserID=%1',
  'user.password': ADMIN_PATH + 'user/index.php?phase=6&UserID=%1',
  'user.rights': ADMIN_PATH + 'user/index.php?phase=8&UserID=%1',
  'user.subscribers': ADMIN_PATH + 'user/index.php?phase=15&UserID=%1',
// /* no such page actually */  'user.switch': ADMIN_PATH + 'user/index.php?phase=12&UserID=%1',

  // рассылка по базе
  'user.mail': ADMIN_PATH + 'user/MessageToAll.php',

  // действия с группами пользователей
  'usergroup.list': ADMIN_PATH + 'user/group.php',
  'usergroup.add': ADMIN_PATH + 'user/group.php?phase=5',
  'usergroup.edit': ADMIN_PATH + 'user/group.php?phase=3&PermissionGroupID=%1',
  'usergroup.rights': ADMIN_PATH + 'user/group.php?phase=8&PermissionGroupID=%1',

  // Инструменты
  'tools.sql': ADMIN_PATH + 'sql/index.php',
  'tools.seo': ADMIN_PATH + 'siteinfo/?url=%1',
  'tools.usermail': ADMIN_PATH + 'user/MessageToAll.php',
  'tools.backup': ADMIN_PATH + 'dump.php?phase=%1',
  'tools.patch': ADMIN_PATH + 'patch/?phase=%1',
  'tools.activation': ADMIN_PATH + 'patch/activation.php?phase=%1',
  'tools.installmodule': ADMIN_PATH + 'modules/index.php?phase=5',
  'tools.totalstat': ADMIN_PATH + 'report/index.php?phase=%1',
  //'tools.lastchanges': ADMIN_PATH + 'report/last.php',
  'tools.systemmessages': ADMIN_PATH + 'report/system.php',
  'tools.reportstatus': ADMIN_PATH + 'report/report.php',
  'tools.html': ADMIN_PATH + 'html/',
  'tools.copy' : ADMIN_PATH + 'subdivision/copy.php?copy_type=%1&catalogue_id=%2&sub_id=%3',
  'trash.list': ADMIN_PATH + 'trash/index.php',
  'trash.settings': ADMIN_PATH + 'trash/index.php?phase=3',

  // Справка
  'help.about': ADMIN_PATH + 'about/index.php',

  // Настройки системы
  'system.settings': ADMIN_PATH + 'settings.php',
  'system.edit': ADMIN_PATH + 'settings.php?phase=1',

  // Переадресации
  'redirect.settings': ADMIN_PATH + 'redirect.php',
  'redirect.add': ADMIN_PATH + 'redirect.php?phase=1',
  'redirect.edit': ADMIN_PATH + 'redirect.php?phase=1&RedirectID=%1',

  // Управление задачами
  'cron.settings': ADMIN_PATH + 'crontasks.php',
  'cron.add': ADMIN_PATH + 'crontasks.php?phase=1',
  'cron.edit': ADMIN_PATH + 'crontasks.php?phase=4&CronID=%1',

  // Модули

  'module.list': ADMIN_PATH + 'modules/index.php',
  'module.settings': ADMIN_PATH + 'modules/index.php?phase=2&module_name=%1',
  'modules.settings': ADMIN_PATH + 'modules/index.php?phase=2&module_name=%1', // SAME

  // Избранное
  
  'favorite.other': ADMIN_PATH + 'subdivision/full.php?CatalogueID=%1',
  'favorite.add': ADMIN_PATH + 'subdivision/favorites.php?phase=1',
  'favorite.list': ADMIN_PATH + 'subdivision/favorites.php?phase=1',

  1: '' // dummy entry
};
