<?php
/* $Id: full.php 5254 2011-08-31 10:20:28Z gaika $ */

# вывод полной информации об объекте

$action = "full";

$NETCAT_FOLDER = join( strstr(__FILE__, "/") ? "/" : "\\", array_slice( preg_split("/[\/\\\]+/", __FILE__), 0, -2 ) ).( strstr(__FILE__, "/") ? "/" : "\\" );
@include_once ($NETCAT_FOLDER."vars.inc.php");
require ($INCLUDE_FOLDER."index.php");

$ignore_array = array('cond_user', 'cond_mod','cond_date', 'cond_where',
                     'query_select', 'query_from', 'query_group', 'query_join', 'query_where', 'query_order',
                     'ignore_all','ignore_sub','ignore_cc','ignore_check',
                     'result_vars', 'f_ncTitle', 'f_ncKeywords', 'f_ncDescription');

foreach ( $ignore_array as $v ) {
  unset($$v);
}


$cc_env = & $current_cc;

$classPreview = $_GET['classPreview'] + 0;
// Если режим предпросмотра то заменим $current_cc данными из сессии.
if ( $classPreview == ($cc_env["Class_Template_ID"] ? $cc_env["Class_Template_ID"] : $cc_env["Class_ID"]) && (isset($_SESSION["PreviewClass"][$classPreview])) && ($_SESSION["PreviewClass"][$classPreview]) ) {
  $magic_gpc = get_magic_quotes_gpc();
  foreach ($_SESSION["PreviewClass"][$classPreview] as $tkey => $tvalue) {
    $cc_env[$tkey] = $magic_gpc ? stripslashes($tvalue) : $tvalue;
  }
  // Отключим кеширование в режиме предпросмотра.
  $cc_env['Cache_Access_ID'] = 2;

}


// cache section
if ( nc_module_check_by_keyword("cache") && $current_cc['Cache_Access_ID']==1) {
  // startup values
  $cached_data = "";
  $cached_eval = false;

  try {
    $nc_cache_full = nc_cache_full::getObject();
    // cache auth addon string
    $cache_for_user = $nc_cache_full->authAddonString( $cc_env['CacheForUser'], $current_user);
    // check cached data
    $cached_result = $nc_cache_full->read($classID, $message, $REQUEST_URI.$cache_for_user, $current_cc['Cache_Lifetime']);
    if ($cached_result!=-1) {
      // get cached parameters
      list ($cached_data, $cached_eval, $cache_vars) = $cached_result;
      // debug info
      $cache_debug_info = "Readed, sub[".$sub."], cc[".$cc."], Access_ID[".$current_cc['Cache_Access_ID']."], Lifetime[".$current_cc['Cache_Lifetime']."], bytes[".strlen($cached_data)."], eval[".(int)$cached_eval."]";
      $nc_cache_full->debugMessage($cache_debug_info, __FILE__, __LINE__);
      
       // extract cached object variables
      if ( !empty($cache_vars) ) {
        extract($cache_vars);
        if ( $f_ncTitle ) $nc_core->page->set_metatags('title', $f_ncTitle);
        if ( $f_ncKeywords ) $nc_core->page->set_metatags('keywords', $f_ncKeywords);
        if ( $f_ncDescription ) $nc_core->page->set_metatags('description', $f_ncDescription);
      } 
  
      // return cache if cache data without "nocache" blocks
      if (!$cached_eval) {
        // template header
        eval ("echo \"".$template_header."\";");
        // echo simple html cached data
        echo $cached_data;
        // template footer
        eval ("echo \"".$template_footer."\";");
        exit;
      }
    }
    // set marks into the fields
    $no_cache_marks = $nc_cache_full->nocacheStore( $cc_env );
  }
  catch (Exception $e) {
    // for debug
    $nc_cache_full->errorMessage($e);
  }
}

// component custom settings
$cc_settings = &$cc_env["Sub_Class_Settings"];

$ignore_user = true;

$subHost = "http://".($current_cc['Hidden_Host'] ? ( strchr($current_cc['Hidden_Host'], '.') ? $current_cc['Hidden_Host'] : $current_cc['Hidden_Host'].'.'.$DOMAIN_NAME ) : $DOMAIN_NAME);

$message_level_count = 0;
$parent_message_tree[$message_level_count] = $message;

if (!$user_table_mode) {
  while ($parent_message_tree[$message_level_count]) {
    $parent_mess_res = $db->get_var("SELECT `Parent_Message_ID` FROM `Message".$classID."` WHERE `Message_ID` = '".(int)$parent_message_tree[$message_level_count]."'");
    if ($db->num_rows) {
      $message_level_count++;
      $parent_message_tree[$message_level_count] = $parent_mess_res;
    }
    else break;
  }
}

// class settings execute
if ($cc_env["Settings"]) eval ($cc_env["Settings"]);

// cache eval section
if ( nc_module_check_by_keyword("cache") && $current_cc['Cache_Access_ID']==1 && is_object($nc_cache_full) && $cached_eval && $cached_result!=-1) {
  // template header
  eval ("echo \"".$template_header."\";");
  // eval cached data
  eval("echo \"".$cached_data."\";");
  // template footer
  eval ("echo \"".$template_footer."\";");
  
  exit;
}

$component = new nc_Component( $classID, $cc_env['System_Table_ID']);
$component->make_query();

$field_vars = $component->get_fields_vars();
$date_field = $component->get_date_field();

$cond_date = false;
if (!$ignore_user) $cond_user = " AND a.`User_ID` = '".(int)$AUTH_USER_ID."'";
if (!$admin_mode && !$ignore_check)	$cond_mod = " AND a.`Checked` = 1";
if ($date) $cond_date = " AND a.`".$date_field."` LIKE '".$db->escape($date)."%'";

// ignore section
if (!$ignore_sub && !$user_table_mode) $cond_where .= " AND a.`Subdivision_ID` = '".(int)$sub."'";
if (!$ignore_cc && !$user_table_mode) $cond_where .= " AND a.`Sub_Class_ID` = '".(int)$cc."'";
// query_where
if ($query_where) $cond_where .= " AND ".$query_where;

if (!$ignore_all) {
  $message_select = "SELECT ".$component->get_fields_query().( $query_select ? ", ".$query_select : "")."
                     FROM (`".($user_table_mode ? "User" : "Message".$classID)."` AS a
                     ".( $query_from ? ", ".$query_from : "").")
                     ".$component->get_joins()." ".($query_join ? " ".$query_join : "").
                     " WHERE 1=1 ".$cond_where.$cond_user.$cond_mod.$cond_date."
                       AND a.`".($user_table_mode ? "User" : "Message")."_ID` = '".(int)$message."'";

}
else {
  $message_select = "SELECT ".$query_select." FROM ".$query_from.
  ($query_join ? " ".$query_join : "").
  ($query_where ? " WHERE ".$query_where : "").
  ($query_group ? " GROUP BY ".$query_group : "");
}

$db->num_rows = 0;
$resMsg = $db->get_row($message_select, ARRAY_N);

if (!$db->num_rows) {
  // ошибка в запросе
  $nc_is_error = $db->is_error;

	eval("echo \"".$template_header."\";");
  
  if ( $nc_is_error ) {
    echo NETCAT_FUNCTION_FULL_SQL_ERROR_USER;
  }

	eval("echo \"".$template_footer."\";");
	exit;
}

if (!$ignore_all) {
  $fetch_row = "list(".$field_vars.($result_vars?", ".$result_vars : "").") = \$resMsg;";
}
else {
  $fetch_row = "list(".$result_vars.") = \$resMsg;";
}

eval ($fetch_row);



// разрешить html-теги и перенос строки
$cc_env['convert2txt'] = "";
$text_fields = $component->get_fields(3);
foreach ( $text_fields as $field ) {
  $format = nc_field_parse_format($field['format'], 3);
  // разрешить html
  if (!$cc_env['AllowTags'] && !$format['html'] || $format['html'] == 2 ) $cc_env['convert2txt'] .= "\$f_".$field['name']." = htmlspecialchars(\$f_".$field['name'].");";
  // перенос строки
  if ($cc_env['NL2BR'] && !$format['br'] || $format['br'] == 1)$cc_env['convert2txt'] .= "\$f_".$field['name']." = nl2br(\$f_".$field['name'].");";
  if ($format['bbcode'] ) $cc_env['convert2txt'] .= "\$f_".$field['name']." = nc_bbcode(\$f_".$field['name'].",  '', 1 );";
}
$text_fields = $component->get_fields(1);
foreach ( $text_fields as $field ) {
  if (!$cc_env['AllowTags']  ) $cc_env['convert2txt'] .= "\$f_".$field['name']." = htmlspecialchars(\$f_".$field['name'].");";
  if ($cc_env['NL2BR'] ) $cc_env['convert2txt'] .= "\$f_".$field['name']." = nl2br(\$f_".$field['name'].");";
}
unset($format);
unset($text_fields);

eval ($cc_env['convert2txt']);



// Multiselect
$multilist_fileds = $component->get_fields(10);
if ( !empty($multilist_fileds) ) {
  // просмотр каждого поля типа multiselect
  foreach ( $multilist_fileds as $multilist_filed) {
    // таблицу с элементами можно взять их кэша, если ее там нет - то добавить
    if ( !$_cache['classificator'][$multilist_filed['table']] ) {
      $db_res = $db->get_results("SELECT `".$multilist_filed['table']."_ID` AS ID, `".$multilist_filed['table']."_Name` AS Name, `Value`
                                   FROM `Classificator_".$multilist_filed['table']."`", ARRAY_A);
      if ( !empty($db_res)) {
        foreach ( $db_res as $v) { // запись в кэш
          $_cache['classificator'][$multilist_filed['table']][$v['ID']] = array($v['Name'], $v['Value']);  
        }
      }
      unset($db_res);
    }
    
    ${"f_".$multilist_filed['name']."_id"} = array();
    ${"f_".$multilist_filed['name']."_value"} = array();
    
    if ( ($value = ${"f_".$multilist_filed['name']} )) { // значение из базы
      ${"f_".$multilist_filed['name']} = array();
      $ids = explode(',', $value);
      if ( !empty($ids) ) {
        foreach ( $ids as $id ) { // для каждого элемента по id определяем имя
          if ($id) {
            array_push(${"f_".$multilist_filed['name']}, $_cache['classificator'][$multilist_filed['table']][$id][0]);
            array_push(${"f_".$multilist_filed['name']."_value"}, $_cache['classificator'][$multilist_filed['table']][$id][1]);
            array_push(${"f_".$multilist_filed['name']."_id"}, $id);
          }
        }
      }
    }
    // default value
    if ( !is_array(${"f_".$multilist_filed['name']}) ) ${"f_".$multilist_filed['name']}  = array();
  }
  unset($ids);
  unset($id);
  unset($value);
}

// 'left join' used to provide compatibility with old fs ($f_File_url)
$res = $db->get_results("SELECT fd.`Field_ID` AS field_id, fd.`Field_Name` AS field, ft.`File_Path` AS path, ft.`Virt_Name` AS name, ft.`Download` AS download
  FROM `Field` AS fd
  LEFT JOIN `Filetable` AS ft
  ON (fd.`Field_ID` = ft.`Field_ID` AND ft.`Message_ID` = '".(int)$message."')
  WHERE ".($user_table_mode
    ? "fd.`Class_ID` = 0 AND `System_Table_ID` = 3"
    : "fd.`Class_ID` = '".(int)$classID."'")."
  AND fd.`TypeOfData_ID` = 6", ARRAY_A);

foreach ((array)$res AS $row) {
  $field_value = ${"f_".$row['field']}; // то, что хранится в базе
  // возможен случай, что файла нет.
  if ( !$field_value ) continue;
  $field_value = explode(':', $field_value);
  
  // оригинальное имя, тип, размер
  ${"f_".$row['field']."_name"} = $field_value[0];
  ${"f_".$row['field']."_type"} = $field_value[1];
  ${"f_".$row['field']."_size"} = $field_value[2];


  if ($row['name']) { // Protected FileSystem 
    ${"f_".$row['field']} = $SUB_FOLDER.rtrim($HTTP_FILES_PATH, '/').$row['path']."h_".$row['name'];
    ${"f_".$row['field']."_url"} = $SUB_FOLDER.rtrim($HTTP_FILES_PATH, '/').$row['path'].$row['name'];
    ${"f_".$row['field']."_download"} = $row['download'];
  }
  else if ( $field_value[3]) { // Original FileSystem
    ${"f_".$row['field']} = ${"f_".$row['field']."_url"} = $SUB_FOLDER.$HTTP_FILES_PATH.$field_value[3];
  }
  else { // Simple FileSystem
    $ext = substr($field_value[0], strrpos($field_value[0], "."));
    ${"f_".$row['field']."_url"} = ${"f_".$row['field']} = $SUB_FOLDER.$HTTP_FILES_PATH.$row['field_id']."_".$f_RowID.$ext; 
  }
}
// free memory
unset($field_value);
unset($ext);
unset($res);

// user group
if ( $user_table_mode ) {
  $nc_user_group = $db->get_results("SELECT ug.`User_ID`, ug.`PermissionGroup_ID`, g.`PermissionGroup_Name` 
                                     FROM `User_Group` AS ug,`PermissionGroup` AS g
                                     WHERE User_ID = '".intval($message)."'
                                     AND g.`PermissionGroup_ID` = ug.`PermissionGroup_ID` ", ARRAY_A);
  if ( !empty($nc_user_group ) ) {
    foreach ( $nc_user_group as $v ) {
      $f_PermissionGroup[$v['PermissionGroup_ID']] = $v['PermissionGroup_Name']; 
    }
  }
  unset($nc_user_group);
}
  
// date values
$f_Created_year = substr($f_Created,0,4);
$f_Created_month = substr($f_Created,5,2);
$f_Created_day = substr($f_Created,8,2);
$f_Created_hours = substr($f_Created,11,2);
$f_Created_minutes = substr($f_Created,14,2);
$f_Created_seconds = substr($f_Created,17,2);

$f_LastUpdated_year = substr($f_LastUpdated,0,4);
$f_LastUpdated_month = substr($f_LastUpdated,4,2);
$f_LastUpdated_day = substr($f_LastUpdated,6,2);
$f_LastUpdated_hours = substr($f_LastUpdated,8,2);
$f_LastUpdated_minutes = substr($f_LastUpdated,10,2);
$f_LastUpdated_seconds = substr($f_LastUpdated,12,2);

if ($date_field) {
  if (!$admin_mode) {
    eval("\$dateLink = \$f_".$date_field."_year.\"/\".\$f_".$date_field."_month.\"/\".\$f_".$date_field."_day.\"/\";");
  }
  else {
    eval("\$dateLink = \$f_".$date_field."_year.\"-\".\$f_".$date_field."_month.\"-\".\$f_".$date_field."_day;");
  }
}

// title и метатеги
if ($cc_env['TitleTemplate']) eval("\$f_title = \"".$cc_env['TitleTemplate']."\";");
if ( $cc_env['UseAltTitle'] &&  $f_title)  $nc_core->page->set_metatags('title', $f_title);
if ( $f_ncTitle ) $nc_core->page->set_metatags('title', $f_ncTitle);
if ( $f_ncKeywords ) $nc_core->page->set_metatags('keywords', $f_ncKeywords);
if ( $f_ncDescription ) $nc_core->page->set_metatags('description', $f_ncDescription);



if ($no_cache_marks || $f_title || $f_ncTitle || $f_ncKeywords || $f_ncDescription) {
  // caching variables array
  $cache_vars = array();
  if ( $f_title )$cache_vars['f_title'] = $f_title;
  if ( $f_ncTitle )$cache_vars['f_ncTitle'] = $f_ncTitle;
  if ( $f_ncKeywords )$cache_vars['f_ncKeywords'] = $f_ncKeywords;
  if ( $f_ncDescription )$cache_vars['f_ncDescription'] = $f_ncDescription;
  // get variables names string
  preg_match("/^list\((.*?)\).*?$/", $fetch_row, $matches);
  if ($matches[1]) {
    // variables by name array
    $cache_vars_name = explode(",", $matches[1]);
    if ( !empty($cache_vars_name) ) {
      // correcting
      foreach ($cache_vars_name as $k => $v) {
        $_variable_name = trim( str_replace('$', "", $v ) );
        $cache_vars[$_variable_name] = $$_variable_name;
        // clear
        unset($_variable_name);
      }
      // clear
      unset($cache_vars_name);
    }
  }      
}


$ccLink = $subLink.$cc_keyword.".html";

$component_body = $cc_env['RecordTemplateFull'].$cc_env['Settings'];

$cc_env["AddTemplate"] = $cc_env["AddTemplate"] ? $cc_env["AddTemplate"] : $component->add_form($catalogue, $sub, $cc);
$cc_env["FullSearchTemplate"] = $cc_env["FullSearchTemplate"] ? $cc_env["FullSearchTemplate"] :  $component->search_form(1);
$nc_search_form = "<form method='get' action='".$SUB_FOLDER.$current_sub['Hidden_URL']."'>".showSearchForm($field_descript, $field_type, $field_search, $field_format)."<input type='submit' value='".NETCAT_SEARCH_FIND_IT."' /></form>";


if ($admin_mode) {
  $addLink = $admin_url_prefix."add.php?catalogue=".$catalogue."&amp;sub=".$sub."&amp;cc=".$cc;
  // full link section
  $fullLink = $admin_url_prefix."full.php?catalogue=".$catalogue."&sub=".$sub."&cc=".$cc."&message=".$f_RowID;
  $fullDateLink = $fullLink.$dateLink;
	// ID объекта в шаблоне
	$f_AdminButtons_id = $f_RowID;
	// Приоритет объекта
	$f_AdminButtons_priority = $f_Priority;
	// ID добавившего пользователя
	$f_AdminButtons_user_add = $f_UserID;
	// ID изменившего пользователя
	$f_AdminButtons_user_change = ($f_LastUserID ? $f_LastUserID : "");
	// копировать объект
	$f_AdminButtons_copy = $ADMIN_PATH."objects/copy_message.php?catalogue=".$catalogue."&sub=".$sub."&cc=".$cc."&classID=".$classID."&message=".$f_RowID;
	// изменить
	$f_AdminButtons_change = $SUB_FOLDER.$HTTP_ROOT_PATH."message.php?catalogue=".$catalogue."&sub=".$sub."&cc=".$cc."&message=".$f_RowID."&curPos=".$curPos;
	$editLink = $f_AdminButtons_change;
	// удалить
	$f_AdminButtons_delete = $SUB_FOLDER.$HTTP_ROOT_PATH."message.php?catalogue=".$catalogue."&sub=".$sub."&cc=".$cc."&message=".$f_RowID."&delete=1&curPos=".$curPos;
	$deleteLink = $f_AdminButtons_delete;
	$dropLink = $deleteLink."&posting=1";
	// включить-выключить
	$f_AdminButtons_check = $any_url_prefix.$SUB_FOLDER.$HTTP_ROOT_PATH."message.php?catalogue=".$catalogue."&sub=".$sub."&cc=".$cc."&classID=".$classID."&message=".$f_RowID."&checked=".($f_Checked ? 1 : 2)."&posting=1&curPos=".$curPos.($admin_mode ? "&admin_mode=1" : "");
  $checkedLink = $f_AdminButtons_check;
  $f_AdminButtons = "";
  if (!$user_table_mode) {
    if ($system_env['AdminButtonsType']) {
  		eval("\$f_AdminButtons = \"".$system_env['AdminButtons']."\";");
  	}
  	else {
  	  $f_AdminButtons_buttons = "<a href='#' onclick=\"window.open('".$f_AdminButtons_copy."', 'nc_popup_test1', 'width=800,height=500,menubar=no,resizable=no,scrollbars=no,toolbar=no,resizable=yes'); return false;\"><img src='".$ADMIN_TEMPLATE."img/i_obj_copy.gif' alt='".NETCAT_MODERATION_COPY_OBJECT."' title='".NETCAT_MODERATION_COPY_OBJECT."'></a>";
  	  $f_AdminButtons_buttons.= "<a href='".$f_AdminButtons_check."'><img src='".$ADMIN_TEMPLATE."img/i_obj_turn".($f_Checked ? 'on' : 'off' ).".gif' ".($f_Checked ? "alt='" . NETCAT_MODERATION_TURNTOOFF."'  title='".NETCAT_MODERATION_TURNTOOFF."'" : "alt='".NETCAT_MODERATION_TURNTOON."' title='".NETCAT_MODERATION_TURNTOON."'")."></a>";
  	  $f_AdminButtons_buttons .= "&nbsp;&nbsp;";
  		$f_AdminButtons_buttons .= "<a href='".$f_AdminButtons_change."'><img src='".$ADMIN_TEMPLATE."img/i_obj_edit.gif' alt='".NETCAT_MODERATION_CHANGE."' title='".NETCAT_MODERATION_CHANGE."'></a>";
  		$f_AdminButtons_buttons .= "&nbsp;&nbsp;";
      $f_AdminButtons_buttons.= "<a href='".$f_AdminButtons_delete."'><img src='".$ADMIN_TEMPLATE."img/i_obj_delete.gif' alt='".NETCAT_MODERATION_DELETE."' title='".NETCAT_MODERATION_DELETE."'></a>";
      
      
  		$f_AdminButtons.= "<div class='nc_idtab".($f_Checked ? "" : " nc_idtab_disabled")."'>";
      
  		if ( CheckUserRights( $cc, 'moderate', 1 )==1 || ( CheckUserRights( $cc, 'change', 1 )==1 && $f_AdminButtons_user_add==$AUTH_USER_ID ) ) {
  			$f_AdminButtons.= "<div class='nc_idtab_handler' id='message".$classID."-".$f_RowID."_handler'></div>";
  			$f_AdminButtons.= "<div class='nc_idtab_id'>";
  			$f_AdminButtons.= "<div class='nc_idtab_messageid' title='".NETCAT_MODERATION_ID.": ".$f_AdminButtons_id."'>".$f_AdminButtons_id."</div>";
  			$f_AdminButtons.= "<div class='nc_idtab_priority' title='".NETCAT_MODERATION_PRIORITY.": ".$f_AdminButtons_priority."'>".$f_AdminButtons_priority."</div>";
  			$f_AdminButtons.= "<div class='nc_idtab_adduser' title='".NETCAT_MODERATION_ADDEDON.": ".$f_AdminInterface_user_add."'	>".($f_AdminInterface_user_add ? $f_AdminInterface_user_add : $f_AdminButtons_user_add)."</div>";
  			$f_AdminButtons.= ($f_AdminButtons_user_change
          ? "<div class='nc_idtab_edituser' title='".NETCAT_MODERATION_CHANGED.": ".$f_AdminInterface_user_change."'>".( $f_AdminInterface_user_change ? $f_AdminInterface_user_change : $f_AdminButtons_user_change )."</div>"
  				: "");
  			$f_AdminButtons.= "</div>";
  			$f_AdminButtons.= "<div class='nc_idtab_buttons'>".$f_AdminButtons_buttons."</div>";
  			$f_AdminButtons.= "<div class='ncf_row nc_clear'></div>";
  		}
      else {
  			$f_AdminButtons.= "<div class='nc_idtab_handler' id='message".$classID."-".$f_RowID."_handler'></div>";
  			$f_AdminButtons.= "<div class='nc_idtab_id'>";
  			$f_AdminButtons.= "<div class='nc_idtab_messageid error' title='".NETCAT_MODERATION_ERROR_NORIGHT."'>".NETCAT_MODERATION_ERROR_NORIGHT."</div>";
  			$f_AdminButtons.= "</div>";
  			$f_AdminButtons.= "<div class='ncf_row nc_clear'></div>";
  		}
  		$f_AdminButtons.= "</div><div class='ncf_row nc_clear'></div>";
  	}
  }
}
else {
  $msgLink = $f_Keyword ? $f_Keyword : $cc_keyword."_".$f_RowID;
  $fullLink = $subLink.$msgLink.".html";
  $fullRSSLink = $cc_env['AllowRSS'] ? $subLink.$msgLink.".rss" : "";
  $fullDateLink = $subLink.$dateLink.$msgLink.".html";
  $editLink = $subLink."edit_".$msgLink.".html"; // ccылка для редактирования
  $deleteLink = $subLink."delete_".$msgLink.".html"; //            удаления 
  $dropLink = $subLink."drop_".$msgLink.".html"; //            удаления без подтверждения
  $checkedLink = $subLink."checked_".$msgLink.".html"; //            включения\выключения
  $subscribeMessageLink = $subLink."subscribe_".$msgLink.".html"; // подписка на объект
  // действие с компонентом
  $subscribeLink = $SUB_FOLDER.$current_cc['Hidden_URL']."subscribe_".$current_cc['EnglishName'].".html";
  $searchLink = $SUB_FOLDER.$current_cc['Hidden_URL']."search_".$current_cc['EnglishName'].".html";
  $addLink = $SUB_FOLDER.$current_cc['Hidden_URL']."add_".$current_cc['EnglishName'].".html";
}


/* Следующий и предыдущий объект */
$nc_next_object = "";
$nc_prev_object = "";

if ( nc_strpos($component_body, '$nc_next_object') !== false || nc_strpos($component_body, '$nc_prev_object') !== false ) {
  // сортировка и запрос
  $sort_by = $query_order ? $query_order : $cc_env['SortBy'] ? $cc_env['SortBy'] : "a.".($user_table_mode ? "`".$AUTHORIZE_BY."`" : "`Priority` DESC").", a.`LastUpdated` DESC";
  $nc_res = $db->get_results("SELECT a.`Message_ID`, a.`Keyword`
                               FROM `".($user_table_mode ? "User" : "Message".$classID)."` AS a
                               WHERE a.`Sub_Class_ID` = '".$cc."'
                               ORDER BY ".$sort_by , ARRAY_A);
  // предыдущий и следующий объект находятся рядом с текущим
  for ( $i=0; $i < $db->num_rows; $i++ ) {
    if ( $nc_res[$i]['Message_ID'] == $message ) {
      if ( $i > 0 ) {
        $nc_prev_object = $admin_mode ? $admin_url_prefix."full.php?catalogue=".$catalogue."&amp;sub=".$sub."&amp;cc=".$cc."&amp;message=".$nc_res[$i-1]['Message_ID'] : $cc_env['Hidden_URL'].( $nc_res[$i-1]['Keyword'] ? $nc_res[$i-1]['Keyword'] : $cc_env['EnglishName']."_".$nc_res[$i-1]['Message_ID']).".html";
      }
      if ( $i < $db->num_rows-1 ) {
        $nc_next_object = $admin_mode ? $admin_url_prefix."full.php?catalogue=".$catalogue."&amp;sub=".$sub."&amp;cc=".$cc."&amp;message=".$nc_res[$i+1]['Message_ID'] : $cc_env['Hidden_URL'].( $nc_res[$i+1]['Keyword'] ? $nc_res[$i+1]['Keyword'] : $cc_env['EnglishName']."_".$nc_res[$i+1]['Message_ID']).".html";
      }
      break;
    }
  }
  unset($nc_res);
}

if ( nc_strpos($component_body, '$addForm')    !== false ) eval("\$addForm = \"".$cc_env["AddTemplate"]."\";");
if ( nc_strpos($component_body, '$searchForm') !== false ) eval("\$searchForm = \"".$cc_env["FullSearchTemplate"]."\";");
unset ($component_body);



// save changed $current_cc["RecordTemplateFull"]
// this array is updated in $template_header
$cache_record_template_full = $cc_env['RecordTemplateFull'];

eval ("echo \"".$template_header."\";");

if ( nc_module_check_by_keyword("cache") && $current_cc['Cache_Access_ID'] != 2 ) {
  ob_start("nc_full_message_parse_buffer");
  eval("echo \"".$cache_record_template_full."\";");
  ob_end_flush();
}
else {
  eval("echo \"".$cc_env['RecordTemplateFull']."\";");
}


eval("echo \"".$template_footer."\";");


function nc_full_message_parse_buffer ($buffer) {
  global $REQUEST_URI, $classID, $message, $cache_vars;
  global $MODULE_VARS, $nc_cache_full, $current_sub, $current_cc, $cache_for_user;

  // cache section
  if ( nc_module_check_by_keyword("cache") && $current_cc['Cache_Access_ID']==1 && is_object($nc_cache_full) ) {
    try {
      $bytes = $nc_cache_full->add($classID, $message, $REQUEST_URI.$cache_for_user, $buffer, $cache_vars);
      // debug info
      if ($bytes) {
        $cache_debug_info = "Writed, sub[".$current_sub['Subdivision_ID']."], cc[".$current_cc['Sub_Class_ID']."], Access_ID[".$current_cc['Cache_Access_ID']."], Lifetime[".$current_cc['Cache_Lifetime']."], bytes[".$bytes."]";
        $nc_cache_full->debugMessage($cache_debug_info, __FILE__, __LINE__, "ok");
      }
    }
    catch (Exception $e) {
      // for debug
      $nc_cache_full->errorMessage($e);
    }
  }

  return $buffer;
}

?>